#include <stdio.h>

/*
 Instructions:
 =============
 1. Replace VAL_1 below with the sum of all 8 digits in your student number.
  E.g. 12345678 -> 1+2+3+4+5+6+7+8 = 36.

 2. Replace VAL_2 below with the last digit of your student number, or 10 if it is 0.
  E.g. 12345678 -> 8, 12345670 -> 10.

 3. Compile and run this program.

 4. Include the output of this program and the answers to the questions below
    in a file named a5_2.txt
*/

struct my_struct {
 int a[VAL_1];
 char m[VAL_2];
};

int main() {
 struct my_struct s[10];
 struct my_struct *msp;
 int *ip;
 char *cp;
 printf("1. &s[0] = %d\n",&s[0]);
 printf("2. &s[2] = %d\n",&s[2]);
 ip = &s[3].a[14];
 printf("3. ip = %d\n",ip);
 printf("4. ip + 3 = %d\n",ip+3);
 cp = &s[7].m[5];
 printf("5. cp = %d\n",cp);
 printf("6. cp + 3 = %d\n",cp+3);
 msp = &s[5];
 printf("7. msp = %d\n", msp);
 
 return 0;
}

/*
 Questions:
 ==========
 1. Using only the first two lines of output, what is the size of my_struct?
 2. How can the value of ip as shown on the third line be calculated?
 3. What is the address of the last byte of the array a in the last element of s?
 4. Is the value of ip as shown on the third line beyond the bounds of s[3], and
    if so, where (in terms of s[i].a[j] or s[i].m[j]) is it pointing to?
 5. How can the value of cp as shown on the 5th line be calculated?
 6. Explain the difference between lines 3 and 4, and lines 5 and 6.
 7. Explain how the value of msp in line 7 is calculated, and use this fact to
    derive the address of msp[3].a[10]
 8. Show how to obtain the value of the expression &((msp+1)->m[3]) - &s[4].m[0]
    and explain in words the meaning of this "measurement". (Hint: x->y is
    equivalent to (*x).y when x is a pointer to a structure of type T, and T
    contains a field named y.)
*/
